require({cache:{
'url:slmui/form/templates/RadioButtonSet.html':"<div class=\"dijit dijitReset dijitInline\" data-dojo-attach-point=\"focusNode,overflowContainer\" tabIndex=\"-1\" style=\"overflow-x: auto;\">\r\n        <div style=\"white-space: nowrap; display: inline-block; z-index: 999;\" data-dojo-attach-point=\"radioNode\"></div>\r\n        <div data-dojo-attach-point=\"tickMarks\" style=\"height: 15px; position: relative; white-space: nowrap;\"></div>\r\n</div>",
'url:slmui/form/templates/RadioButton.html':"<div class=\"dijitReset\" wairole=\"presentation\" data-dojo-attach-event=\"onclick:_onClick\" style=\"display: inline-block;\">\r\n    <div class=\"dijitXcitecRadioWrap\">\r\n        <div data-dojo-attach-point=\"borderNode\" class=\"radioButtonContainer\" title=\"${title}\">\r\n            <div class=\"dijitReset dijitXcitecRadioIcon centeredRadioButtonIcon\">\r\n                <input type=\"${type}\" autocomplete=\"off\" class=\"dijitReset dijitCheckBoxInput\" data-dojo-attach-point=\"focusNode\" ${!nameAttrSetting} ${checkedAttrSetting}>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</div>\r\n"}});
define("slmui/form/RadioButtonSet", [
	"dojo/_base/declare", // declare
	"xcitec/form/RadioButton",
	"dijit/form/_FormValueWidget",
	"dijit/_Container",
	"dijit/registry",
	"dojo/dom-construct",
	"dojo/_base/array",
	"dojo/_base/window",
	"dojo/dom-attr",
	"dojo/query",
	"dojo/on",
	"dojo/_base/lang",
	"dojo/dom",
	"dojo/dom-class",
	"dojo/text!slmui/form/templates/RadioButton.html",
	"dojo/text!slmui/form/templates/RadioButtonSet.html",
	"dijit/Viewport",
	"dojo/has",
	"dojo/touch",
	"dojo/dom-geometry",
	"dojo/dom-style"
], function(declare, RadioButton, _FormValueWidget, _Container, registry, domConstruct, array, windowModule, domAttr, query, on, lang, dom, domClass, templateRadioButton, templateRadioButtonSet, Viewport, has, touch, domGeom, style){

	// module:
	//		slmui/form/RadioButtonSet

	var RadioGroup = declare([_FormValueWidget, _Container], {

		// summary:
		//			A vertical radio button group with colored containers for radio buttons.

		// values of each item (Array)
		values: null,
		// short text of each item (Array)
		labels: null,
		// long text of each item (Array)
		descriptions: null,
		// index of currently selected item
		selectedValue: 0,
		// array of item's widgets
//		items: null,
		// widget name
		name: "",
		// state attributes
		readOnly: false,
		disabled: false,
		error: "",
//		required: false,
		// if items exist in srcNodeRef
		empty: false,

		selIndex: -1,
		tabIndex: "-1",

		_buttons: null,
		templateString: templateRadioButtonSet,

		postMixInProperties: function(){
			// summary:
			//			 Parse source and init of the RadioButtonSet
			// tags:
			//			extension
			this.inherited(arguments);
			this._parseSource();
			this._initOptions();
		},

		_initOptions: function(){
			// summary:
			//			Prepare init data
			var opts = [];

			this.selIndex = this.selectedValue;
			for(var i = 0; i < this.values.length; i++){
				var selected;
				if(this.selIndex - 1 == i){
					selected = true;
				}else{
					selected = false;
				}
				opts.push({
					values: this.values[i],
					caption: this.labels[i],
					label: this.descriptions[i],
					checked: selected,
					disabled: this.disabled,
					icon: "",
					captionId: ""
				});
			}

			this.options = opts;
		},

		buildRendering: function(){
			// summary:
			//			Building the DOM model.
			// tags:
			//			extension
			this._buttons = [];
			domConstruct.empty(this.srcNodeRef);
			this.inherited(arguments);
			this._createRadioGroup(this.options);
			dom.setSelectable(this.domNode, false);
		},

		_parseSource: function(){
			// summary:
			//			Parses the HTML source.
			// tags:
			//			protected
			var srcNodeName = (has('ie') == 8) ? this.srcNodeRef.nodeName.toLowerCase() : this.srcNodeRef.localName;
			var component = (srcNodeName=="div")?"div":"option";
			var boxes = query("> " + component, this.srcNodeRef);
			if(boxes.length == 0){
				this.empty = true;
			}
			var _this = this;
			this.values = boxes.map(function(node){
				return domAttr.get(node, "value");
			});
			this.labels = boxes.map(function(node){
				return domAttr.get(node, "label");
			});
			this.descriptions = boxes.map(function(node){
				return node.innerHTML;
			});
			boxes.forEach(function(node, index){
				if(domAttr.get(node, "selected") == "true"){
					_this.selectedValue = index + 1;
				}
			})
		},

		_createRadioGroup: function(otpions){
			// summary:
			//			Creates radiobuttons and puts into DOM model.
			// tags:
			//			private
			var self = this;
			var ind = 0;

			array.forEach(otpions, function(node, index){
				var text = "";
				text = node.label;

				// create RadioButtons according set of options
				var radioButton = new BlockRadioButton({
					name: self.name,
					checked: node.checked,
					disabled: self.disabled,
					readOnly: self.readOnly,
					caption: text,
					captionId: node.captionId,
					icon: node.icon,
					value: node.values,
					index: ind,
					parent: self,
					title: node.caption
				});
				if(index == (self.values.length - 1)){
					domClass.add(radioButton.domNode, "rightRadioButton");
				}
				if(index == 0){
					domClass.add(radioButton.domNode, "leftRadioButton");
				}
				self._buttons[ind] = radioButton;
				ind++;
				self.radioNode.appendChild(radioButton.domNode);
				radioButton.domNode.onchange = "";
				on(radioButton.domNode, "click", lang.hitch(radioButton, self.changeState));
			});


			var leftLabel = this.labels[0];
			var rightLabel = this.labels[this.labels.length - 1];
			var leftTickMark = domConstruct.create("div", {innerHTML: leftLabel, style: "width: 50% !important; overflow: hidden; float: left; text-overflow: ellipsis;"});
			this.tickMarks.appendChild(leftTickMark);
			if(otpions.length >= 2){
				this.tickMarks.appendChild(domConstruct.create("div", {innerHTML: rightLabel, style: "overflow: hidden; text-overflow: ellipsis; text-align: right;"}));
			}
			this.tickMarks.style.width = this.radioNode.scrollWidth + 'px';
		},

		startup: function(){
			// summary:
			// 			Start listening the viewport resize event
			// tags:
			//			extension
			this.inherited(arguments);
			this.own(Viewport.on("resize", lang.hitch(this, "resize")));
			this.resize();
		},

		resize: function(){

			if(this.options.length < 1){return;}
			//summary:
			//			Recalculates the width of the buttons to set the equal distance between all the buttons.

//			this.radioNode.style.overflowX='hidden';
			var minMargin = 10/2;
			var maxMargin = 30/2;

			var leftButtonNode = query(".leftRadioButton", this.domNode)[0];
			var rightButtonNode = query(".rightRadioButton", this.domNode)[0];
			var middleButtons = query("div.dijitXcitecRadio:not(.leftRadioButton):not(.rightRadioButton)", this.domNode)
			var n = this.options.length;

			var totalWidth = this.domNode.parentNode.offsetWidth;

            var radioButtonWidth = 34;
			var visibleWidth = radioButtonWidth * n + minMargin * (n-1);

            var halfPiece = minMargin;
            if(visibleWidth < totalWidth) {
                halfPiece = (totalWidth - radioButtonWidth * n - minMargin - 3 ) / (2 * n - 2);
                if (halfPiece > maxMargin) {
                    halfPiece = maxMargin;
                }
            }

			leftButtonNode.style.marginRight = halfPiece + 'px';
			rightButtonNode.style.marginLeft = halfPiece + 'px';

			for (var i = 0; i<middleButtons.length; i++) {
				middleButtons[i].style.marginRight = halfPiece + 'px';
				middleButtons[i].style.marginLeft = halfPiece + 'px';
			}

//			this.radioNode.style.overflowX='auto';
			var scrollingWidth = this.radioNode.scrollWidth;

			if(scrollingWidth == 0) scrollingWidth = visibleWidth;

			this.tickMarks.style.width = scrollingWidth + 'px';
		},

		postCreate: function() {
			this.inherited(arguments);

			if(has('ie') == 9){ // SRM-11209: refresh nodeTableContainer to prevent its height surge
				var controlHeight = this.overflowContainer.offsetHeight;
				var that = this;
				touch.move(this.domNode.parentNode.parentNode.parentNode, function(){
					if(that.overflowContainer.offsetHeight != controlHeight){
						that.overflowContainer.style.display = 'none';
						that.overflowContainer.style.display = 'block';
					}
				});
			}
		},

		changeState: function(){
			// summary:
			//			changes the state of radiobutton set, if new radio button was selected
			if(this.readOnly || this.disabled){
				return;
			}
			var widget = registry.byNode(this.domNode);
			widget.focus();
			if(widget.index != widget.parent.selIndex){
				if(widget.parent.selIndex > -1){
					var prev = widget.parent._buttons[widget.parent.selIndex];
					prev.set('checked', false);
				}
				widget.parent.selIndex = widget.index;
				widget.parent._onChange();
			}
		},

		_onChange: function(e){
			// summary:
			// 			user defined function
			this.onchange();
		},

		onchange: function(){
			// summary:
			// 			for wicket use in template
		},

		_setDisabledAttr: function(/*Boolean*/ value){
			// tags:
			//		extension protected
			this._set('disabled', value);
		}
	});

	var BlockRadioButton = declare(RadioButton, {

		// summary:
		//			Extended xcitec/form/RadioButoon. Now it has an colored block as a background.
		templateString: templateRadioButton,

		_setCheckedAttr: function(/*Boolean*/ value){

			// summary:
			//			Colors the checked radio button container
			//			and uncolors the unchecked one
			// tags:
			//			extension protected
			this.inherited(arguments);
			if(value){
				domClass.add(this.borderNode, "checkedRadioButtonContainer");
			}else{
				domClass.remove(this.borderNode, "checkedRadioButtonContainer");
			}
		}
	});


	return RadioGroup;

});