define("slmui/layout/_ChapterItem", [
	'dojo/_base/declare',
	'dojo/_base/array',
	'dojo/_base/lang',
	'dijit/registry',
	'dijit/_Container',
	'xcitec/layout/_ChapterItem',
	'xcitec/xcitecUtil'
], function(declare, array, lang, registry, _Container, _xChapterItem, xcitecUtil){
	return declare([_xChapterItem], {

		// summary:
		//		Deprecated. Will be used util full migration to IDX. Control's wrapper with label for Chapter.
		// tags:
		//		deprecated

		processAdditionalProperties: function(/*DomNode*/ controlNode){
			// summary:
			//		Collect necessary attrs from control.
			// tags:
			//		extension

			var control = registry.byNode(controlNode);
			this.label = control.label;
			this.labelId = control.labelId;
			this.labelPos = control.labelPos;
			this.labelType = control.labelType || this.labelType;
			this.labelRequired = xcitecUtil.str2bool(control.required);
			this.labelDisabled = xcitecUtil.str2bool(control.disabled);
			this.errorMsg = control.error;
			this.controlView = control.controlView || control.controlview || this.controlView;
			this.labelClickEvent = control.onLabelClick;
			this.widthInPercent = control.widthInPercent;
			if(!this.widthInPercent){
				this.widthInPercent = '100';
			}
			this.inner = xcitecUtil.str2bool(control.inner);
			var parentWidget = registry.getEnclosingWidget(control.domNode.parentNode);
			if(this.inner && parentWidget && parentWidget.widthInPercent){
				this.widthInPercent = parentWidget.widthInPercent;
			}
			if (this.controlView) this.processViewMode();
		},

		resize: function(){
			array.forEach(registry.findWidgets(this.domNode), function(child){
				if(lang.isFunction(child.resize)){
					child.resize();
				}
			});
		}
	});
});
