define("xcitec/Image", [
	"dojo",
	"dojo/_base/declare",
	"dojo/dom-attr",
	"dojo/dom-style",
	"dojo/on",
	"dijit/_TemplatedMixin",
	"dijit/_WidgetBase",
  "./_base/ImageFactory"
], function (dojo, declare, domAttr, domStyle, on, _Templated, _Widget, ImageFactory) {

	var Image = declare( [_Widget, _Templated], {
	
		templateString: '<img class="${imageClass}" src="${_blankGif}" data-dojo-attach-point="imageNode"/>',
	
		src: "",
		width: "",
		height: "",
		imageClass: "",
		borderAttr: true,
		url: "",
		webSiteScriptUrl: "",
		
	
		postMixInProperties: function(){
			if(this.imageClass){
				this.imageClass = ImageFactory.createIconCss(this.imageClass);
			}
			this.inherited(arguments);
		},
	
		_fillContent: function(){
			var _this = this;
			if(this.border){
				domStyle.set(this.domNode, "border", "solid 1px gray");
			}
			if(this.src){
				domAttr.set(this.domNode, "src", this.src);
			}
			if(this.width){
				domAttr.set(this.domNode, "width", this.width + "px");
			}
			if(this.height){
				domAttr.set(this.domNode, "height", this.height + "px");
			}
			if(this.url){
				domStyle.set(this.imageNode, "cursor", "pointer");
				domAttr.set(this.domNode, "onclick", this.webSiteScriptUrl);
			}
			this.inherited(arguments);
		}
	});
	return Image;
});
