/*
todo: still there is a problem with max width for IE6 when label inside template
      getting label width in postCreate and startup return 0.

todo: general problem if widget in template calculation of sizes is impossible.
     if label is not visible - size is always 0!
 */

define("xcitec/Label", ["dojo/_base/declare",
        "dojo/dom-construct",
        "dojo/dom-class",
        "dojo/_base/lang",
        "dojo/dom",
        "dojo/dom-style",
        "dojo/dom-geometry",
        "dojo/has",
        "dijit/_WidgetBase",
        "dijit/_TemplatedMixin",
        "./xcitecUtil", "dijit/_OnDijitClickMixin"], function(declare, domConstruct, domClass, lang, dom, domStyle, geometry, has, _Widget, _Templated, xcitecUtil, _OnDijitClickMixin){
  return declare([_Widget, _OnDijitClickMixin], {

    useFFhack: true,
    baseClass: "xcitecLabel",
    baseClassExtended: "",
    additionalClasses: "",
    labelType: "",
    labelId: "",
    label: "",
    htmlFor: "",
    color: "",

    inline: false,

    // marking that label is an anchor (has onLabelClick event defined)
    hasAnchor: false,

    // marking that long label can be wrapped and takes more then one line
    allowWrap: false,

    // label "owner" control is marked as required
    required: false,
    // label "owner" control is marked as disabled
    disabled: false,
    // label "owner" control is marked as error
    error: false,

    //requiredPrefix: "*",
    requiredPrefix: "",

    maxLabelWidth: 0,

    postMixInProperties: function(){
      this.inherited(arguments);

		if(this.label){
			this.label = xcitecUtil.escapeXml(this.label);
		}

      if(this.labelType){
        this.baseClass = xcitecUtil.createTypedStyleClass(this.baseClass, this.labelType);
      }

      if(this.allowWrap){
              this.label = this.label.replace(/&lt;br&gt;/gm, "<br>");
              this.useFFhack = false;
        this.additionalClasses += " xcitecLabelMultiline";
      }

      if((has("ff") || has("ie") == 8) && this.inline){
        this.additionalClasses += " xcitecElipsesLabelInLine";
      }

      if(this.hasAnchor){
        this.baseClassExtended += " " + this.baseClass + "Anchor";
      }
      if(this.disabled){
        this.baseClassExtended += " " + this.baseClass + "Disabled";
      }else if(this.required){
        this.baseClassExtended += " " + this.baseClass + "Required";
      }
      if(this.error){
        this.baseClassExtended += " " + this.baseClass + "Error";
      }

    },

    buildRendering: function(){
      var source = this.srcNodeRef;
      if(source){
        if(!this.htmlFor) this.htmlFor = source.htmlFor;
        if(!("label" in this.params)){
          this.label = source.innerHTML;
        }
      }

		if(this.required && this.requiredPrefix && this.label){
			this.label = this.requiredPrefix + this.label;
		}

      this.domNode = domConstruct.create("label");
      this.domNode.innerHTML = this.label;

      var classValue = "xcitecElipsesLabel " + this.additionalClasses + " " + this.baseClass + this.baseClassExtended;
      domClass.add(this.domNode, classValue);
      //this.inherited(arguments);

      if(has("ff") && has("ff") < 4 && this.useFFhack){
        var description = document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "label");
        description.setAttribute("align", "end");
        // XUL description doesn't process html escape characters!!!
        description.setAttribute("value", lang.trim(this.domNode.textContent));
        //description.setAttribute("tooltiptext","Vk TEST");
        this.domNode.innerHTML = '';
        this.domNode.appendChild(description);
      }
      if(this.htmlFor){
        this.domNode.htmlFor = this.htmlFor;
      }
		if(this.color && this.color != ""){
			this.domNode.style.color = this.color;
		}
      dom.setSelectable(this.domNode, false);
      this.connect(this.domNode, "ondijitclick", this._onLabelClick);
      this.connect(this.domNode, "onmouseover", this._onLabelOver);
      this.connect(this.domNode, "onmouseout", this._onLabelOut);
    },

    getLabelWidth: function(){
      var cbox = geometry.getContentBox(this.domNode);
      var labelWidth = cbox.w;
      if(this.maxLabelWidth > 0 && labelWidth > this.maxLabelWidth) labelWidth = this.maxLabelWidth;
      return labelWidth;
    },

    _isAdminClickAllowed: function(){
      return this.labelId && lang.isFunction(xcitecUtil.onLabelAdminClick);
    },

    _onLabelClick: function(evt){
      if(this._isAdminClickAllowed() && evt.ctrlKey && evt.altKey){
        //console.log(this.declaredClass + ": _onLabelClick: labelId: " + this.labelId);
        xcitecUtil.processLabelAdminClick(this.labelId);
        evt.preventDefault(), evt.stopPropagation()
      }else if(this.hasAnchor){
        this.onLabelClick();
        evt.preventDefault(), evt.stopPropagation()
      }else if(this.htmlFor && dom.byId(this.htmlFor)){
        dom.byId(this.htmlFor).focus();
        evt.preventDefault(), evt.stopPropagation()
      }
    },

    _onLabelOver: function(evt){
      if(this._isAdminClickAllowed() && evt.ctrlKey && evt.altKey){
        domClass.add(this.domNode, 'xcitecLabelAdminHover');
        this._adminHovered = true;
      }
    },

    _onLabelOut: function(evt){
      if(this._adminHovered){
        domClass.remove(this.domNode, 'xcitecLabelAdminHover');
      }
    },

    onLabelClick: function(){
      // user defined Event
    },

    _setLabelAttr: function(/*String*/ value){
      this.label = value;
      if(this.required && this.requiredPrefix && this.label){
        this.label = this.requiredPrefix + this.label;
      }
    },

	  _setDisabledAttr: function(/*Boolean*/ value){
		  this._set('disabled', value);
	  },

    logLabelWidth: function(/*String*/ value){
      var labelWidth = geometry.getContentBox(this.domNode).w;
      //console.log("["+ this.id +"] "+ value +" label width: "+ labelWidth );
      //console.log("["+ this.id +"] "+ value +" max-width : " + dojo.style(this.domNode, "max-width"));
    }

  });
});


