define("xcitec/xlayout/QuestionV2", [
	"dojo",
	"dojo/_base/declare",
	"dojo/dom-attr",
	"dojo/dom-class",
	"../layout/Chapter",
  "./_QuestionV2Item"
], function (dojo, declare, domAttr, domClass, Chapter, _QuestionV2Item) {

	/* xcitec.xlayout.QuestionV2 is a layout control which is used to show questions in qualification */
	
	var QuestionV2 = declare( Chapter, {
	    baseClass: "fieldsetChapter questionV2",
	    useLabelAsCaption: false,
	    hasOwnLabelProcessing: false,
	
	   // is onDelete attrinbute set in markup
	    onDeleteAttr: null,
	    onSettingsAttr: null,
	    onChangedAttr: null,
	    onChangedNewAttr: null,
	
	    designMode: false,
	
	    score: "",
	    ko: "",
	    critical: "",
	
	    changedOld: "",
	
	    hidden: false,
	
	    required: false,

        //value to adapt previews labelHolderColumn if current widget has no label
        newRowSpan: 1,
        _labelHolderColumn: null,

        _processChildren: function(/*DomNode*/ source){
            this.inherited(arguments);

            if(this.newRowSpan>1){
                this._labelHolderColumn.rowSpan = this.newRowSpan;
            }
        },

	    buildControlHolderNode: function(/*WidgetDomNode*/ controlNode, /*LabelDomNode*/ labelNode) {
            var noLabelMode = this._labelHolderColumn && !((domAttr.get(controlNode, "controlView") && domAttr.get(controlNode, "controlView").toUpperCase() == "WIDE") || domAttr.get(controlNode, "label"));
            if (noLabelMode) {
                this.newRowSpan++;
            }

	        var controlHolderWidget = new _QuestionV2Item({ controlNode:controlNode,
	                                                                       labelNode:labelNode, designMode: this.designMode, noLabelMode: noLabelMode});
            if(!noLabelMode){
                if(this.newRowSpan>1){
                    this._labelHolderColumn.rowSpan = this.newRowSpan;
                }
                this.newRowSpan = 1;
                this._labelHolderColumn = controlHolderWidget.labelHolderColumnNode;
            }
	        return controlHolderWidget.domNode;
	    },    
	
	    postMixInProperties: function() {
	        this.inherited(arguments);
	        this.onDeleteAttr = 'onDelete' in this.params;
	        this.onSettingsAttr = 'onSettings' in this.params;
	        this.onChangedAttr = 'onChanged' in this.params;
	        this.onChangedNewAttr = 'onChangedNew' in this.params;
	        if (this.required) {
	            this.baseClass = this.baseClass + " dijitXcitecQuestionRequired";
	        }
	    },
	
	    postCreate: function(){
	    this.inherited(arguments);
	        if(this.hidden){
	           domClass.add(this.domNode.parentNode, "questionHidden");
	        }
	    },
	
	    
	    
	    /* start declaring actions */
	    onDelete: function() {
	
	    },
	
	    onSettings: function() {
	
	    },
	    
	    onChanged: function() {
	      
	    },
	    
	    onChangedNew: function() {
	      
	    }, 
	    /* end declaring actions */
	
	    // getter for onDelete attribute
	    isDeleteSet: function() {
	        return this.onDeleteAttr;
	    },
	
	    isSettingsSet: function() {
	        return this.onSettingsAttr; 
	    },
	    
	    isChangedSet: function() {
	        return this.onChangedAttr;  
	    },
	    
	    isChangedNewSet: function() {
	        return this.onChangedNewAttr;  
	    }, 
	
	    isScoreSet: function() {
	        return ("score" in this.params);
	    },
	
	    isCriticalSet: function() {
	        return ("critical" in this.params);
	    },
	    
	    isChangedOldSet: function() {
	        return ("changedOld" in this.params);
	    },
	    
	    isKoSet: function() {
	        return ("ko" in this.params);
	    }
	});

	return QuestionV2;
});
